package cn.com.infosec.asn1.mozilla;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERIA5String;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.x509.SubjectPublicKeyInfo;

public class PublicKeyAndChallenge extends ASN1Encodable {
   private ASN1Sequence pkacSeq;
   private SubjectPublicKeyInfo spki;
   private DERIA5String challenge;

   public static PublicKeyAndChallenge getInstance(Object obj) {
      if (obj instanceof PublicKeyAndChallenge) {
         return (PublicKeyAndChallenge)obj;
      } else if (obj instanceof ASN1Sequence) {
         return new PublicKeyAndChallenge((ASN1Sequence)obj);
      } else {
         throw new IllegalArgumentException("unkown object in factory: " + obj.getClass().getName());
      }
   }

   public PublicKeyAndChallenge(ASN1Sequence seq) {
      this.pkacSeq = seq;
      this.spki = SubjectPublicKeyInfo.getInstance(seq.getObjectAt(0));
      this.challenge = DERIA5String.getInstance(seq.getObjectAt(1));
   }

   public DERObject toASN1Object() {
      return this.pkacSeq;
   }

   public SubjectPublicKeyInfo getSubjectPublicKeyInfo() {
      return this.spki;
   }

   public DERIA5String getChallenge() {
      return this.challenge;
   }
}
